#define HID // If you want to debug before turning arduino into HID comment here

#ifdef HID
#include "Keyboard.h"
#endif

const int min_threshold = sq(200); // The threshold is betwee 0-1024

const int pin[4] = {A4, A3, A1, A2}; // Put here the different Analog input you use for Taiko
const int key[4] = {'d', 'f', 'j', 'k'};
int raw[4] = {0, 0, 0, 0};

bool Trig = false;
int key_index = 0;


void setup() {

#ifdef HID
  Keyboard.begin();
#endif
  Serial.begin(9600);

}

void loop() {

  raw[0] = sq(analogRead(pin[0]));
  delayMicroseconds(200);
  raw[1] = sq(analogRead(pin[1]));
  delayMicroseconds(200);
  raw[2] = sq(analogRead(pin[2]));
  delayMicroseconds(200);
  raw[3] = sq(analogRead(pin[3]));
  delayMicroseconds(200);

  int energy =  raw[0] + raw[1] + raw[2] + raw[3];

  if( (energy > min_threshold)&&(!Trig) )
  {
    Trig = true;
    key_index = 0;
    int distance = energy-raw[0];
    for(int i = 0; i <= 3; i++)
    {
      int temp_distance = energy - raw[i];
      if( temp_distance < distance )
      {
        distance = temp_distance;
        key_index = i;
      }

    }
#ifdef HID
    Keyboard.press(key[key_index]);
#else
    Serial.println(key[key_index]);
#endif

  }

  if((energy< min_threshold)&&Trig)
  {
    Trig = false;

#ifdef HID
  Keyboard.release(key[key_index]);
#endif
    
  }



}
